--                                       ____                                        ____
--This is a UP_DOWN counter that when UP_DOWN is'1' Counter,counts to UP and when UP_DOWN is'0' Counter,counts-
--turn down.
--In this Counter can Change value of counter.
--This valuer do whit tow CONSTANT value.For example START_VALUE is first value that this counter starts to count.
--Next CONSTANT is finish of counting,its name is END_VALUE.

--BASES         ____
--          (UP_DOWN)
--When this base is 'HIGH' counter counts UP and when this base is 'LOW' counter turn to down counting.
--          (in_clk)
--This base is inpin for "CLOCK" from last counter or osilator.
--          (OUTp)
--This port is for value of counter output.
--          (out_clk)
--This is a clock output that whit UP counting after end value below for one cycle of in_clk and when down counting
--below to '1' for one cycle of in_clk after arrival to END_VALUE from START_VALUE.
--          (rst)
--This pin is for Asynchronous reset and resets counter to 0.
--          (CS)
--When this pin select(can choose one case of'LOW or HIGH'in plan) then can enable or unable the counter whit CS pin.
--          (inh_out)
--When COUNTER is 2 then this pin is high.
--          (inh0_out)
--When COUNTER is 0 then this pin is high.
---------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------


LIBRARY IEEE;                                                 -------------------------------------------------------
USE IEEE.STD_LOGIC_1164.ALL;                                  --    When UP_DOWN is '1' Then Counter Increments    --
                                                              --    When UP_DOWN is '0' Then Counter Decrements    --
ENTITY LD_INH_out_CNTR IS                                     --                 _____________                     --
PORT(in_clk,up_down   : IN STD_LOGIC;                         --                /  ____       \                    --
     out_clk,inh_out,inh0_out:OUT STD_LOGIC;                  --    YES    ----|UP_DOWN        |    / Q[0..2]      --
 OUTp : buffer integer range 0 to 2                           --    NO     ----|rst        OUTp|===/======  YES    --
    );                                                        --    NO     ----|CS             |  /                --
CONSTANT end_value : INTEGER := 2 ;                           --    YES    ----|>in_clk        |                   --
CONSTANT start_value: INTEGER := 0 ;                          --               |        out_clk|----        YES    --
CONSTANT in_clock_edge: STD_logic:='1';                       --               |        inh_out|----        YES    --
CONSTANT cs_enable: STD_LOGIC:='1';                           --               |       inh0_out|----        YES    --
END LD_INH_out_CNTR ;                                         --                \_____________/                    --
                                                              --                                                   --
                                                              -------------------------------------------------------


---------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------
-- For use of CS clear all " -- "" befor every statement that is ( for use of " CS " ) after next them and change
-- in_clk in PROCESS & IF in_clk'EVENT AND in_clk=in_clock_edge to clk. and add CS in ENTITY => 'CS :IN STD_LOGIC'
-- Saman-Moshtagh !
---------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------

ARCHITECTURE behavioral OF LD_INH_out_CNTR IS
--SIGNAL clk:STD_LOGIC;                       -- FOR USE OF " CS "
BEGIN


--WITH cs SELECT-- FOR USE OF " CS "
--clk<=in_clk WHEN cs_enable,      -- Use Of Constant " cs_enable "
--'X' WHEN OTHERS;-- FOR USE OF " CS "
PROCESS(in_clk)
VARIABLE mnt : INTEGER RANGE start_value TO end_value;      -- Use Of Constant " start_value & end_value "
BEGIN
--IF rst='1'THEN
--   mnt:=0;
--ELSE
case mnt is
      when 0=>
             inh0_out<='1';
             inh_out <='0';
      when 2=>inh_out<='1';
      when others=>
                 inh0_out<='0';
                 inh_out<='0';
      end case;
  IF in_clk'EVENT AND in_clk=in_clock_edge THEN      -- Use Of Constant " in_clock_edge "
      IF up_down='1'THEN
         CASE mnt IS
         WHEN end_value=>out_clk<='1';
         WHEN OTHERS=>out_clk<='0';
         END CASE;
         IF mnt=end_value THEN      -- Use Of Constant " end_value "
            mnt:=start_value;      -- Use Of Constant " start_value "
         ELSE
            mnt:=mnt+1;
         END IF;
      ELSIF up_down='0'THEN
         CASE mnt IS
         WHEN start_value=>out_clk<='1';
         WHEN OTHERS=>out_clk<='0';
         END CASE;
         IF mnt=start_value THEN      -- Use Of Constant " start_value "
            mnt:=end_value;      -- Use Of Constant " end_value "
         ELSE
            mnt:=mnt-1;
         END IF;
      END IF;
   END IF;

--END IF;
OUTp<=mnt;
END PROCESS;
END behavioral;
